
/*******************************************************************
 $CRT 17 Dec 1996 : hb

 $AUT Holger Burkarth
 $DAT >>Beep.c<<   26 Jan 1997    13:18:42 - (C) ProDAD
*******************************************************************/

//##ex mcpp:cppc -gs -o pos:pos/Ex/Beep p:pLib/StartCode.o p:/pOS_RKRM/pAudio/Beep.c p:pLib/StdIO.o -l pOSStub -l pOS

/***********************************************************
  pOS programing example - Copyright (C) 1995-97 proDAD

  This code was written as an easy to understand example,
  how to program pOS features. It is provided 'as-is',
  without any express or implied warranty.

  Permission is hereby granted to use, copy and modify
  this source code for any purpose, without fee, subject
  to the following conditions:

    (1) This notice may not be removed or altered from any
        source distribution.

    (2) Altered source versions must be plainly marked as
        such, and must not be misrepresented as being
        the original source code.

    (3) If only executable code is distributed, then the
        accompanying documentation have to state that
        "this software is based in part on examples of
        the pOS developer packet".

    (4) Permission for use of this code is granted only
        if the user accepts full responsibility for any
        undesirable consequences. proDAD accept NO LIABILITY
        for damages of any kind.

  proDAD
***********************************************************/

/*\
*** Example:
***
\*/


#define __COMPUTER_AMIGA 1
#define NOMYDEBUG

#include "p:pExec/Types.h"
#include "p:pDOS/ArgTags.h"
#include "p:pDOS/DosSig.h"
#include "p:pDOS/DosErrors.h"
#include "p:pAudio/Audio.h"
#include "p:pAudio/AudioTags.h"
#include "p:pAudio/InfoData.h"
#include "p:pAudio/StdAMap.h"

#include "p:proto/pLibExt.h"
#include "p:proto/pExec2.h"
#include "p:proto/pDOS2.h"
#include "p:proto/pAudio2.h"

#ifdef _____ME_____
  #include "grund/inc_string.h"
  #include "grund/inc_stdio.h"
#else
 #ifdef __cplusplus
 extern "C" {
 #endif
  #include <string.h>
  #include <stdio.h>
 #ifdef __cplusplus
 }
 #endif
#endif


const CHAR *HelpText=
""
;

const CHAR *PrgHeader=
"";

const CHAR *PrgVerText=
"$VER: 1.0 ("__DATE2__") (Copyright 1996-97 by proDAD) (Created by Holger Burkarth)";


struct pOS_AudioDevice *gb_AudioBase;

/*----------------------------------
-----------------------------------*/
#ifdef __cplusplus
extern "C"
#endif

VOID main()
{
  struct pOS_DosArgs* Args;
  UWORD Err=0;
  ULONG Ops[3]={0xffff,3000,30};

  Args=pOS_ReadDosArgs(
//  0                    1               2
"VOLUME=VOL/K/N, FREQUENCE=FRQ/K/N, CYCLES=CYC/K/N",
Ops,sizeof(Ops)/sizeof(ULONG),

    ARGTAG_PrgHeaderText, (ULONG)PrgHeader,    /* kurze Programm-Beschreibung */
    ARGTAG_HelpText,      (ULONG)HelpText,     /* Help-Texte */
    ARGTAG_PrgVerText,    (ULONG)PrgVerText,   /* VER-String */
    TAG_END);

  if(Args) {
    gb_AudioBase=(pOS_AudioDevice*)pOS_OpenLibrary("pAudio.library",0);

    if(gb_AudioBase) {
      static SBYTE Sample[]={0,10,20,30,40,50,60,70,80,90,100,110,120,0};
      pOS_Std8AudioMap Map={0};
      Map.bam_Audio.am_Type=AUDIOMAPTYP_Std8Bit;
      Map.bam_Audio.am_Frequence=100; // Default
      Map.bam_Length=sizeof(Sample)/sizeof(SBYTE);
      Map.bam_Sample=Sample;

      pOS_PlayChannel(&Map.bam_Audio,
           AUDIOTAG_Volume,    *((ULONG*)Ops[0]),
           AUDIOTAG_Frequence, *((ULONG*)Ops[1]),
           AUDIOTAG_Cycles,    *((ULONG*)Ops[2]),
           TAG_END);

      pOS_CloseLibrary((pOS_Library*)gb_AudioBase);
    }
    else printf("Cannot open audio.library\n");
    pOS_DeleteDosArgs(Args);  /* Args freigeben */
  }
  else Err=DOSFAIL_FAIL;  /* vollkommen fehlgeschlagen */

  pOS_SetShellFail(Err);
}
